# -----------------------------------------------------------------------------
# Programm         : K a n t e . p m
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Erstellt         : 10. Februar 2004
# Zuletzt gendert : 10. Februar 2004
# Aufgabe          : Kantenklasse
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Globale private Datei-Variablen:
# -----------------------------------------------------------------------------
my $Debug  = 2; # Debug level


# -----------------------------------------------------------------------------
# Klasse           : K a n t e
# abgeleitet von   : none
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Beschreibung     : Eine Kanten-Klasse.
# Attribute        : a                  - Anfangsecke
#                    e                  - Endecke
#                    form               - Form der Kante fr die Darstellung
# Klassen-Methoden : new                - Erstellt ein Objekt dieser Klasse.
# Objekt-Methoden  : a                  - Getter / Setter
#                    e                  - Getter / Setter
#                    form               - Getter / Setter
#                    inzidiert_mit_ecke - Test, ob Kante an Ecke stt.
# -----------------------------------------------------------------------------
# 0.0.1 - 10.02.2004 - CD - erstellt
# -----------------------------------------------------------------------------
package Graph::GED::Kante;


use strict;
use warnings;

use Data::Dumper;

use Graph::GED::Basis;

# -----------------------------------------------------------------------------
# Globale ffentliche Klassen-Variablen:
# -----------------------------------------------------------------------------
our @ISA   = ('Graph::GED::Basis');


sub new {
# -----------------------------------------------------------------------------
# Methode      : n e w
# Klasse       : Graph::GED::Kante
# -----------------------------------------------------------------------------
# Autor        : Christian Dhl
# Aufgabe      : Erzeugt eine neue Kante.
# Parameter    : Klasse
# Rckgabewert : Das geblesste neue Objekt.
# -----------------------------------------------------------------------------
# 0.0.1 - 08.02.2004 - CD - erstellt
# 0.0.2 - 10.02.2004 - CD - Vereinfachung durch Verwendung der Klasse Basis.
# -----------------------------------------------------------------------------

    my $self  = shift;
    my $class = (ref $self) || $self;

    #--------------------------------------------------------------------------
    # Ausgabe der Aufrufparameter:
    #--------------------------------------------------------------------------
    print "Graph::GED::Kante::new\n",
          "\tself       = '$self'\n",
          "\tclass      = '$class'\n",
          "\tParameter  = @_\n",
          if $Debug > 1;


    $self = $class->SUPER::new();


    #--------------------------------------------------------------------------
    # Nun setzen wir noch ein paar Attribute:
    #--------------------------------------------------------------------------
    $self->a   (-1);
    $self->e   (-1);
    $self->form('');


    #--------------------------------------------------------------------------
    # ... und geben das erzeugte Objekt zurck:
    #--------------------------------------------------------------------------
    return $self;

} # sub Kante::new


# -----------------------------------------------------------------------------
# The getter/setter methods:
# -----------------------------------------------------------------------------
sub e    { return shift->_property('e',    @_) }
sub a    { return shift->_property('a',    @_) }
sub form { return shift->_property('form', @_) }


sub inzidiert_mit_ecke {
# -----------------------------------------------------------------------------
# Methode      : i n z i d i e r t _ m i t _ e c k e
# Klasse       : Graph::GED::Kante
# -----------------------------------------------------------------------------
# Autor        : Christian Dhl
# Aufgabe      : Testet, ob die Kante mit der gegebenen Ecke inzidiert.
# Parameter    : Ecke (Index, nicht Objekt)
# Rckgabewert : wahr oder falsch
# -----------------------------------------------------------------------------
# 0.0.1 - 10.02.2004 - CD - erstellt
# -----------------------------------------------------------------------------

    my $self = shift;
    my $ecke = shift;

    return ($self->a() == $ecke or $self->e() == $ecke) ? 1 : 0;
} # sub inzidiert_mit_ecke


return 1;

__END__

=head1 NAME

Kante.pm - a module for a edge of a graph


=head1 COPYRIGHT

Copyright 2004 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
